---------------------------------------------------------
-- Example of redundant arguments
--   Extracted from
--   M. Wand and I. Siveroni
--   Constraint systems for useless variable elimination
--   POPL99, pages 291-302, ACM Press, 1999.
---------------------------------------------------------

data nat = Z | S nat

loop :: nat -> nat -> nat -> nat
loop a bogus Z     = loop (S a) (S bogus) (S Z)
loop a bogus (S x) = a

--------------------------------
-- Redundant arguments:
--   loop: 2

--------------------------------
-- After analysis and erasure:
-- 
-- data nat = Z | S nat
-- 
-- loop :: nat -> nat -> nat
-- loop a Z     = S a
-- loop a (S x) = a

