-- Example from program specialization
-- applast (from DPPD library of benchmarks: 
--           http://www.ecs.soton.ac.uk/~mal/systems/dppd.html )

-- ******Original program 
-- data Nat = Z | S Nat
-- 
-- append::[Nat] -> [Nat] -> [Nat]
-- append []     y = y
-- append (x:xs) y = x:(append xs y)
-- 
-- last::[Nat] -> Nat
-- last (x:[])  = x
-- last (x:y:ys) = last (y:ys)

-- ******Specialized for goal: last (append xs (x:[]))

-- ******Specialized program 

data Nat = Z | S Nat

applast ::[Nat] -> Nat -> Nat
applast []     z = z
applast (x:xs) z = lastnew x xs z 

lastnew::Nat -> [Nat] -> Nat -> Nat
lastnew x []     z = z
lastnew x (y:ys) z = lastnew y ys z

-- ******After analysis and erasure:
-- 
-- data Nat = Z | S Nat
-- 
-- applast :: nat -> nat
-- applast z = z
-- 
-- lastnew :: nat -> Nat
-- lastnew z = z
