---------------------------------------------------------
-- Example of redundant arguments
--   Extracted from
--   T. Arts and J. Giesl. 
--   A collection of examples for termination of 
--   term rewriting using dependency pairs.
--   Technical Report AIB-2001-09 RWTH Aachen, 2001. 
--   (Example 2.24)
---------------------------------------------------------

data nat = Z | S nat

f :: nat -> nat
f Z         = S Z
f (S Z)     = S Z
f (S (S x)) = f (f (S x))

-- After analysis and erasure:
-- 
-- data nat = Z | S nat
-- 
-- f :: nat
-- f = Z

