-- Example from program specialization
-- plus_leq

-- ******Original program 
-- 
-- data nat = Z | S nat 
-- 
-- plus :: nat -> nat -> nat
-- plus Z     x = x
-- plus (S x) y = S (plus x y)
-- 
-- leq :: nat -> nat -> Bool
-- leq Z     x     = True
-- leq (S x) Z     = False
-- leq (S x) (S y) = leq x y

-- ******Specialized for goal: leq x (plus x y)

-- ******Specialized program 

data nat = Z | S nat 

leq_pe :: nat -> nat -> Bool
leq_pe Z     x = True
leq_pe (S x) y = leq_pe x y

-- ******After analysis and erasure:
-- 
-- data nat = Z | S nat 
-- 
-- leq_pe :: Bool
-- leq_pe = True
