-- Example from program specialization
-- sum_allzeros

-- ******Original program 
-- 
-- data nat = Z | S nat 
-- 
-- plus :: nat -> nat -> nat
-- plus Z     x = x
-- plus (S x) y = S (plus x y)
-- 
-- sum :: [nat] -> nat
-- sum []     = Z
-- sum (x:xs) = plus x (sum xs)
-- 
-- allzeros :: [nat] -> [nat]
-- allzeros []     = [] 
-- allzeros (x:xs) = Z:(allzeros xs)

-- ******Specialized for goal: sum (allzeros x)

-- ******Specialized program 

data nat = Z | S nat 

sum_pe :: [nat] -> nat
sum_pe []     = Z
sum_pe (x:xs) = sum_pe xs

-- ******After analysis and erasure:
-- 
-- data nat = Z | S nat 
-- 
-- sum_pe :: nat
-- sum_pe = Z
